package org.infinispan.loaders.database;

import org.infinispan.loaders.AbstractCacheLoaderConfig;
import org.infinispan.loaders.jdbc.connectionfactory.ConnectionFactoryConfig;

public class DataBaseCacheLoaderConfig extends AbstractCacheLoaderConfig {

    private static final long serialVersionUID = -6870217557529843902L;

    private ConnectionFactoryConfig connectionFactoryConfig = new ConnectionFactoryConfig();
    private String tableEntryMapperClass;
    private String query;

    public DataBaseCacheLoaderConfig() {
	super();
    }

    public DataBaseCacheLoaderConfig(
	    ConnectionFactoryConfig connectionFactoryConfig) {
	this();
	this.connectionFactoryConfig = connectionFactoryConfig;
    }

    public String getQuery() {
	return this.query;
    }

    public void setQuery(String query) {
	this.query = query;
    }

    public String getTableEntryMapperClass() {
	return this.tableEntryMapperClass;
    }

    public void setTableEntryMapperClass(String tableEntryTransformerClass) {
	this.tableEntryMapperClass = tableEntryTransformerClass;
    }

    public void setConnectionFactoryClass(String connectionFactoryClass) {
	testImmutability("connectionFactoryConfig");
	this.connectionFactoryConfig
		.setConnectionFactoryClass(connectionFactoryClass);
    }

    public ConnectionFactoryConfig getConnectionFactoryConfig() {
	return connectionFactoryConfig;
    }

    /**
     * Jdbc connection string for connecting to the database. Mandatory.
     */
    public void setConnectionUrl(String connectionUrl) {
	testImmutability("connectionFactoryConfig");
	this.connectionFactoryConfig.setConnectionUrl(connectionUrl);
    }

    /**
     * Database username.
     */
    public void setUserName(String userName) {
	testImmutability("connectionFactoryConfig");
	this.connectionFactoryConfig.setUserName(userName);
    }

    public void setDatasourceJndiLocation(String location) {
	testImmutability("datasourceJndiLocation");
	this.connectionFactoryConfig.setDatasourceJndiLocation(location);
    }

    /**
     * Database username's password.
     */
    public void setPassword(String password) {
	testImmutability("connectionFactoryConfig");
	this.connectionFactoryConfig.setPassword(password);
    }

    /**
     * The name of the driver used for connecting to the database. Mandatory,
     * will be loaded before initiating the first connection.
     */
    public void setDriverClass(String driverClassName) {
	testImmutability("connectionFactoryConfig");
	this.connectionFactoryConfig.setDriverClass(driverClassName);
    }

}