package test.org.infinispan.loaders.database;


import java.util.Properties;

import org.infinispan.client.hotrod.Flag;
import org.infinispan.client.hotrod.RemoteCache;
import org.infinispan.client.hotrod.RemoteCacheManager;
import org.testng.annotations.Test;

import static org.testng.Assert.*;

public class TestHotRodClient
{
   
   @Test
   public void testClient() {
      Properties properties = new Properties();
      
      properties.put("infinispan.client.hotrod.server_list", "127.0.0.1");
      properties.put("infinispan.client.hotrod.marshaller", "org.infinispan.marshall.VersionAwareMarshaller");
      
      RemoteCacheManager remoteCacheManager = new RemoteCacheManager(properties);
      
      RemoteCache<Long, MockCacheEntry> cache = remoteCacheManager.getCache();
      
      MockCacheEntry loadedEntry = cache.get(1);    
      
      assertNotNull(loadedEntry);
      assertEquals(Long.valueOf(1), loadedEntry.getId());
      assertEquals("field1", loadedEntry.getField1());
      assertEquals("field2", loadedEntry.getField2());
      assertEquals("field3", loadedEntry.getField3());
   }

}
